function WhammyButton_OnLoad( self )
	self:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	self:RegisterForDrag("RightButton");
	self.dragme = false;
end

function WhammyButton_OnDragStart( self )
	self.dragme = true;
end

function WhammyButton_OnDragStop( self )
	self.dragme = false;
end

function WhammyButton_OnUpdate( self )
	if (self.dragme == true) then
		WhammyButton_IconBeingDragged();
	end
end

function WhammyButton_OnEnter( self )
	GameTooltip:SetOwner(self, "ANCHOR_LEFT");
	GameTooltip:SetText("      Whammy: v"..WhammyVers.."|n"..W_kMiniMapButton_Text);
	GameTooltip:Show();
end

function WhammyButton_OnClick(self, ...)
	local arg1 = ...;

	if ( InCombatLockdown() ) then --if we we are incombat, don't allow hiding/showing of frames or other changes.
		UIErrorsFrame:AddMessage(WC_InCombatError, 1.0, 0.0, 0.0, 53, 5);
	else
		if ( arg1 == "LeftButton" and not IsShiftKeyDown() ) then --just a left click, show/hide the whammy frame
			Whammy_Slash_Command_Handler(); --clcking the button is the same as typing /whammy, so use the same handler
		elseif ( arg1 == "LeftButton" and IsShiftKeyDown() ) then --a shift left click show the config frame
			WC.Config_Frame_Toggle();
		elseif ( arg1 == "RightButton" and IsShiftKeyDown() ) then --shift right click, show the info/help frame
			W.Info_Button_Click();
		end
	end
end

function WhammyButton_OnLeave(self)
	GameTooltip:Hide();
end

function WhammyButton_Move()
	local x = (82 * cos(W_Options.Angle))
	local y = (82 * sin(W_Options.Angle))
	W_MiniMap_ButtonFrame:SetPoint("CENTER","Minimap","CENTER", x,y);
end


function WhammyButton_IconBeingDragged()
	--figure out what the angle is from the center of the map
	
	local xpos,ypos = GetCursorPosition() 
    local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom() 

    xpos = xmin-xpos/UIParent:GetScale()+82 
    ypos = ypos/UIParent:GetScale()-ymin-82
	
	local radians = -math.atan2(ypos,xpos); --get the angle (in degrees) of the x,y coords (rise, run format)
	local degrees = math.deg( radians ) - 180; --convert to degrees
	local degrees = math.floor(degrees)
	if ( degrees < 0 ) then
		degrees = 360 - math.abs(degrees)
	end
	
	W_Options.Angle = degrees
	WhammyConfigFrame.miniMapSlider:SetValue(W_Options.Angle);
	WhammyButton_Move();
end